"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addCommas = void 0;

var _toNumber = require("./to-number");

const addCommas = input => {
  const string = (0, _toNumber.toNumber)(input).toString() || '';
  const [beforeDecimal, afterDecimal] = string.split('.');

  if (beforeDecimal.length <= 3) {
    return string + (afterDecimal ? ".".concat(afterDecimal) : '');
  }

  const reversed = beforeDecimal.split('').reverse();
  let result = '';
  reversed.forEach((number, index) => {
    const mod = index % 3;

    if (index && !mod) {
      result = number + ',' + result;
    } else {
      result = number + result;
    }
  });
  return result + (afterDecimal ? ".".concat(afterDecimal) : '');
};

exports.addCommas = addCommas;